from looqbox.class_loader.class_loader import ClassLoader

class_paths = {
    "ObjMessage": "looqbox.objects.visual.looq_message",
    "ObjImage": "looqbox.objects.visual.looq_image",
    "ObjVideo": "looqbox.objects.media.looq_video",
    "ObjList": "looqbox.objects.visual.looq_list",
    "ObjHTML": "looqbox.objects.looq_html",
    "ObjPDF": "looqbox.objects.looq_pdf",
    "ObjWebFrame": "looqbox.objects.visual.looq_web_frame",
    "ObjTable": "looqbox.objects.visual.looq_table",
    "ObjPlotly": "looqbox.objects.plotly.looq_plotly",
    "ObjForm": "looqbox.objects.looq_form",
    "ObjImageCapture": "looqbox.objects.looq_image_capture",
    "ObjEmbed": "looqbox.objects.looq_embed",
    "ObjText": "looqbox.objects.visual.looq_text",
    "ObjSimple": "looqbox.objects.looq_simple",
    "ObjFormHTML": "looqbox.objects.looq_form_html",
    "ObjRow": "looqbox.objects.container.positional.looq_row",
    "ObjColumn": "looqbox.objects.container.positional.looq_column",
    "ObjSwitch": "looqbox.objects.container.looq_switch",
    "ObjQuery": "looqbox.objects.visual.looq_query",
    "ObjTooltip": "looqbox.objects.container.looq_tooltip",
    "ObjLink": "looqbox.objects.container.looq_link",
    "ObjGauge": "looqbox.objects.visual.looq_gauge",
    "ObjLine": "looqbox.objects.visual.shape.looq_line",
    "ObjFileUpload": "looqbox.objects.looq_file_upload",
    "ObjAudio": "looqbox.objects.media.looq_audio",
    "CssOption": "looqbox.objects.component_utility.css_option"
}


class LazyLoad:
    def __init__(self, function):
        self.function = function

    def __call__(self, *args, **kwargs):
        return ClassLoader(self.function.__name__, class_paths[self.function.__name__]).call_class(*args, **kwargs)

    def __instancecheck__(self, instance):
        self_class = ClassLoader(self.function.__name__, class_paths[self.function.__name__]).load_class()
        return isinstance(instance, self_class)
